4Suite™ API Documentation

# ► Module Ft.Xml.Xslt

4XSLT initialization and XSLT pattern tools

    These are the most common steps for using this XSLT engine:

      1. Create an Ft.Xml.Xslt.Processor.Processor instance:

         from Ft.Xml.Xslt import Processor
         processor = Processor.Processor()

      2. Prepare Ft.Xml.InputSource instances (via their factory)
         for the source XML and for the stylesheet.

      3. Call the Processor's appendStylesheet() method, passing it
         the stylesheet's InputSource.

      4. Call the Processor's run() method, passing it the source
         document's InputSource.

    You can call run() multiple times on different InputSources. When you're
    done, the processor's reset() method can be used to restore a clean slate
    (at which point you would have to append stylesheets to the processor
    again), but in most circumstances it is actually less expensive to just
    create a new Processor instance.

    Copyright 2003 Fourthought, Inc. (USA).
    Detailed license and copyright information: http://4suite.org/COPYRIGHT
    Project home, documentation, distributions: http://4suite.org/

Classes: CategoryTypes, PatternList, XsltException, XsltParserException, XsltRuntimeException |  |  |  | Functions: Transform, TransformPath |  |  |  | Globals: XSL_NAMESPACE

## Modules

ApplyImportsElement | Implementation of the XSLT Spec apply-imports stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
ApplyTemplatesElement | Implementation of xsl:apply-templates instruction
AttributeElement | Implementation of xsl:attribute element
AttributeInfo | Classes that support validation and evaluation of attribute values in XSLT instruction elements
AttributeSetElement | Implementation of the XSLT Spec attribute-set stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
AttributeValueTemplate | Implementation of XSLT attribute value templates
AvtParserc |
BuiltInExtElements | Fourthought proprietary XSLT extension elements
BuiltInExtFunctions | 4XSLT specific extension functions (i.e. ones that create a node set)
CallTemplateElement | Implementation of the XSLT Spec call-template stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
ChooseElement | Implementation of the XSLT Spec choose instruction WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
CommentElement | xsl:comment instruction implementation
ContentInfo |
CopyElement | Implementation of the XSLT Spec copy stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
CopyOfElement | Implementation of the XSLT Spec copy-of element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
Debugger |
DomWriter | DOM DocumentFragment writer for XSLT output
ElementElement | Implementation of xsl:element element
Exslt |
ExtendedProcessingElements | Extended versions of XSLT elements for debugging and execution tracing
ForEachElement | Implementation of the XSLT Spec for-each stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
GenericVariable | Base implementation of XSLT variable assigning elements
HtmlWriter | HTML writer for XSLT processor output
IfElement | Implementation of the XSLT Spec if instruction WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
LiteralElement | Implementation of XSLT literal result elements
MessageElement | Implementation of the XSLT Spec import stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
MessageSource | XSLT error codes and messages
NullWriter | Interface definition for XSLT output writers
NumberElement | Implementation of xsl:number
NumberFormatter |
OtherXslElement | Non-template instructions from the XSLT spec WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
OutputHandler | Manages XSLT output parameters governed by the xsl:output instruction See also Ft.Xml.Xslt.OutputParameters
OutputParameters | Represents XSLT output parameters governed by the xsl:output instruction See also Ft.Xml.Xslt.OutputHandler
ParamElement | Implementation of the XSLT Spec param stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
PlainTextWriter | Plain text writer for XSLT processor output
ProcessingInstructionElement | Implementation of the XSLT Spec processing-instruction stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
Processor | XSLT processing engine
Roman | Light-weight functions to convert from Roman-Numerals to ints, and vice-versa.
RtfWriter | Result Tree Fragment writer for XSLT output
SaxWriter | SAX2 event writer for XSLT output
SortElement | xsl:sort implementation Copyright 2005 Fourthought, Inc. (USA). Detailed license and copyright information: http://4suite.org/COPYRIGHT Project home, documentation, distributions: http://4suite.org/
StringWriter | A specialized XSLT output writer that only captures text output events
Stylesheet | xsl:stylesheet / xsl:transform implementation; various stylesheet internals
StylesheetHandler | Stylesheet tree generator
StylesheetReader | Classes for the creation of a stylesheet object
StylesheetTree | Node classes for the stylesheet tree
TemplateElement | Implementation of the XSLT Spec template stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
TextElement | Implementation of the xsl:text element.
TextSax | Components for reading Text files from a SAX-like producer. WWW: http://4suite.org/4DOM e-mail: support@4suite.org
UndefinedElements | Node classes for the stylesheet tree
ValueOfElement | Implementation of the xsl:value-of element.
VariableElement | Implementation of the XSLT Spec variable stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
WhitespaceElements |
WithParamElement | Implementation of the XSLT Spec with-param stylesheet element. WWW: http://4suite.org/4XSLT e-mail: support@4suite.org
XPathExtensions |
XPatternParserc |
XPatterns | Implement Patterns according to the XSLT spec
XmlWriter | XML writer for XSLT output
XsltContext | Context and state information for XSLT processing
XsltFunctions | Standard XSLT functions

## Classes

class CategoryTypes
  Collection of constants making up the categories of XSLT element

  ### Members

  INSTRUCTION = 0
  RESULT_ELEMENT = 2
  TOP_LEVEL_ELEMENT = 1
class PatternList
  PatternList is a class that is useful for people writing code to process XSLT patterns, especially in groups.

  ### Methods

  __init__(self, patterns, namespaces=None)
    patterns - A list of strings that make up either compiled pattern objects or valid XSLT patterns in string form. It must be either all of one form or all of another namespaces - A namespace dictionary - { prefix: uri, ... } - to be used for setting up expressions in the pattern
  lookup(self, node, context=None)
    Return the patterns that match the node (as a list)
  lookupAsSet(self, node, context=None)
    Returns the patterns that match the node (as a set [dictionary])
  xsltKeyPrep(self, context, node)
    A special utility used for XSLT key preparation. A list of lists is returned. The outer list corresponds to the patterns. Each inner list is either [node] or [] depending on whether or not the node matched the corresponding pattern.

  ### Members

  PARSER = <Ft.Xml.Xslt.XPatternParser object>
class XsltException(Ft.FtException)

  ### Methods

  __init__(self, errorCode, *args)
    Overrides: __init__ from class FtException

  ### Methods inherited from class Ft.FtException

  __getattr__, __repr__, __str__

  ### Methods inherited from class Exception

  __getitem__
class XsltParserException(XsltException)
  The exception raised when an error is encountered during the parsing of a stylesheet. This eliminates the need for location information within each error message.

  ### Methods

  __init__(self, code, locator, *args)
    Overrides: __init__ from class XsltException

  ### Methods inherited from class Ft.FtException

  __getattr__, __repr__, __str__

  ### Methods inherited from class Exception

  __getitem__
class XsltRuntimeException(XsltException)

  ### Methods

  __init__(self, code, xsltelement, *args)
    Overrides: __init__ from class XsltException

  ### Methods inherited from class Ft.FtException

  __getattr__, __repr__, __str__

  ### Methods inherited from class Exception

  __getitem__

## Functions

Transform(source, stylesheet, params=None, output=None)
  Convenience function for applying an XSLT transform. Returns a string.

      source - XML source document in the form of a a string (not Unicode
               object), file-like object (stream), file path, URI or
               Ft.Xml.InputSource.InputSource instance.  If string or stream
               it must be self-contained  XML (i.e. not requiring access to
               any other resource such as external entities or includes)
      stylesheet - XSLT document in the form of a string, stream, URL,
                   file path or Ft.Xml.InputSource.InputSource instance
      params - optional dictionary of stylesheet parameters, the keys of
               which may be given as unicode objects if they have no namespace,
               or as (uri, localname) tuples if they do.
      output - optional file-like object to which output is written (incrementally, as processed)

TransformPath(source, stylesheet)

## Globals

XSL_NAMESPACE = u'http://www.w3.org/1999/XSL/Transform'